#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include "authenticate.h"
#include <pwd.h>
#include <sys/types.h>
#include <string.h>
#include <stdio.h>
#ifdef HAVE_SHADOW_H
#include <shadow.h>
#endif
#include <unistd.h>

#ifdef HAVE_CRYPT_H
#include <crypt.h>
#endif

#define MAXLINE 4096

int authenticate(char * username, char * password) {
  char user[MAXLINE+1], pass[MAXLINE+1];
  char * sys_pw;
  char * crp;
  struct passwd * u;
#ifdef HAVE_SHADOW_H
  struct spwd * s;
#endif
  int len;

  memset(user,0,MAXLINE);
  memset(pass,0,MAXLINE);

  /* extract username */
  crp = index(username,'\r');
  if (crp==NULL) {
    crp = index(username,'\n');
    if (crp==NULL) {
      crp = username + strlen(username);
    }
  }
  len = crp - username;
  strncpy(user,username,len);

  /* extract password */
  crp = index(password,'\r');
  if (crp==NULL) {
    crp = index(password,'\n');
    if (crp==NULL) {
      crp = password + strlen(password);
    }
  }
  len = crp - password;
  strncpy(pass,password,len);

  u = getpwnam(user);

  if (u == NULL || u->pw_passwd == NULL) {
    return 0;
  }

  /* handle shadowed passwd files */
#if HAVE_SHADOW_H
  if (strcmp(u->pw_passwd,"x")==0) {
    s = getspnam(user);
    sys_pw = s->sp_pwdp;
  } else {
    sys_pw = u->pw_passwd;
  }
#else
  sys_pw = u->pw_passwd;
#endif

  if (strcmp(sys_pw,crypt(pass,sys_pw))==0) {
    return 1;
  }
  return 0;
}
